"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FullProcess = void 0;
const index_1 = require("./index");
const concat_1 = require("../../concat");
const readLcov_1 = require("../../utils/readLcov");
const utils_1 = require("../../utils");
class FullProcess extends index_1.BaseProcess {
    constructor(lcovPath, opts = { stream: {} }) {
        super();
        this.firstGitMessage = {};
        if (typeof lcovPath === 'string') {
            this.lcovPath = [lcovPath];
        }
        else {
            this.lcovPath = lcovPath;
        }
        this.opts.cwd = utils_1.getActualGitRepoRoot(opts.cwd);
        this.opts.stream.name = opts.stream.name || 'file';
        this.opts.stream.opts = opts.stream.opts;
        this.opts.output = opts.output;
    }
    exec() {
        return __awaiter(this, void 0, void 0, function* () {
            let createInfo;
            if (this.opts.cwd) {
                createInfo = yield this.getCreateInfo();
                if (createInfo) {
                    this.firstGitMessage = createInfo;
                }
            }
            yield this.getLcov();
            this.format();
            if (this.opts.output) {
                this.output({
                    data: this.formatData,
                    createInfo,
                });
            }
            return {
                data: this.formatData,
                createInfo: createInfo ? createInfo : undefined,
                gitRepoInfo: this.getGitRepoInfo()
            };
        });
    }
    getLcov() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = yield readLcov_1.getLcovFile(this.lcovPath);
            this.lcov = new concat_1.LcovConcat().concat(...res).getRes();
        });
    }
}
exports.FullProcess = FullProcess;
