"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LcovConcat = void 0;
class LcovConcat {
    constructor() {
        this.res = null;
    }
    static judgeInOnce(nowKey, once) {
        const tempNow = nowKey.toLowerCase();
        const onceArray = Object.keys(once);
        for (const key of onceArray) {
            const tempkey = key.toLowerCase();
            if (tempNow.includes(tempkey) || tempkey.includes(tempNow)) {
                return key;
            }
        }
        return '';
    }
    static mergeFile(now, once) {
        const res = Object.assign({}, now);
        let linesCovered = 0;
        let linesValid = 0;
        for (const nowLine of res.lines) {
            for (const onceLine of once.lines) {
                if (+nowLine.number === +onceLine.number) {
                    nowLine.hits += onceLine.hits;
                    break;
                }
            }
        }
        for (const onceLine of once.lines) {
            let flag = false;
            for (const nowLine of res.lines) {
                if (+nowLine.number === +onceLine.number) {
                    flag = true;
                    break;
                }
            }
            if (!flag) {
                res.lines.push(onceLine);
            }
        }
        for (const nowLine of res.lines) {
            if (nowLine.hits !== 0) {
                linesCovered += 1;
            }
            linesValid += 1;
        }
        res.linesCovered = linesCovered;
        res.linesValid = linesValid;
        res.lineRate = +(linesCovered / res.linesValid).toFixed(4);
        return res;
    }
    concat(...args) {
        let lcov = args;
        if (this.res === null) {
            [this.res] = lcov;
            lcov = lcov.slice(1);
        }
        const once = this.res.detail;
        lcov.forEach((item) => {
            Object.keys(item.detail).forEach((nowItem) => {
                const onceKey = LcovConcat.judgeInOnce(nowItem, once);
                if (onceKey !== '') {
                    const onceVal = once[onceKey];
                    delete once[onceKey];
                    const resKey = nowItem.length > onceKey.length ? nowItem : onceKey;
                    const resVal = LcovConcat.mergeFile(item.detail[nowItem], onceVal);
                    once[resKey] = resVal;
                }
                else {
                    once[nowItem] = item.detail[nowItem];
                }
            });
        });
        let linesCovered = 0;
        let linesValid = 0;
        Object.keys(once).forEach((item) => {
            linesCovered += once[item].linesCovered;
            linesValid += once[item].linesValid;
        });
        this.res = {
            $: {
                linesCovered,
                linesValid,
            },
            detail: once,
        };
        return this;
    }
    getRes() {
        return this.res ? this.res : { $: { linesCovered: 0, linesValid: 0 }, detail: {} };
    }
}
exports.LcovConcat = LcovConcat;
