export interface Total {
    linesCovered: number;
    linesValid: number;
}
export interface DetailLines {
    linesCovered: number;
    linesValid: number;
    lineRate: number;
    lines: {
        hits: number;
        number: string;
    }[];
}
export interface Lcov {
    detail: Record<string, DetailLines>;
    $: Total;
}
export interface FormatData {
    total: {
        line: number;
        covLine: number;
        rate: string;
    };
    files: {
        name: string;
        line?: number;
        covLine?: number;
        rate?: string;
        detail?: {
            number: number;
            hits: number;
        }[];
    }[];
}
export interface CommitInfo {
    hash?: string;
    abbrevHash?: string;
    subject?: string;
    authorName?: string;
    authorDate?: string;
    authorEmail?: string;
}
export interface GitRepoInfo {
    remoteUrl: string;
    branch: string;
}
export interface IncreaseResult {
    data: FormatData;
    commit: CommitInfo;
    createInfo: CommitInfo;
    gitRepoInfo: GitRepoInfo;
}
export interface FullResult {
    data: FormatData;
    createInfo?: CommitInfo;
    gitRepoInfo: GitRepoInfo;
}
