"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLcovFile = void 0;
const path_1 = __importDefault(require("path"));
const parsers_1 = require("../parsers");
function getLcovFile(lcovPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const lcovSet = new Set();
        if (typeof lcovPath === 'string') {
            lcovSet.add(path_1.default.resolve(lcovPath));
        }
        else {
            for (const item of lcovPath) {
                lcovSet.add(path_1.default.resolve(item));
            }
        }
        const parserPromise = [];
        for (const item of lcovSet) {
            parserPromise.push(new parsers_1.LcovParser(item).run());
        }
        return Promise.all(parserPromise);
    });
}
exports.getLcovFile = getLcovFile;
